<?php

namespace Drupal\site_studio_wistia_video\Plugin\CustomElement;
 
use Drupal\cohesion_elements\CustomElementPluginBase;

/**
 * Custom element plugin for filtered views Acquia Cohesion.
 *
 * @CustomElement(
 *   id = "wistia_video",
 *   label = @Translation("Wistia Video")
 * )
 */
class WistiaVideo extends CustomElementPluginBase {
  public function getFields() {
    return [
      'wistia_video_url' => [
        'title' => 'Wistia Video URL',
        'type' => 'textfield',
        'required' => TRUE,
        'validationMessage' => 'This field is required.',
      ]
    ];
  }

  /**
   * {@inheritdoc}
   */
  public function render($element_settings, $element_markup, $element_class, $element_context = []) {

    $args1 = $element_settings['wistia_video_url'];
    // dump($args1);
    $settings = [];
    $settings += $this->getGlobalPlayerSettings();
    // exit;
    // Render the element.
    return [
      '#theme' => 'wistia_video_element_template',
      '#elementSettings' => $element_settings,
      '#elementMarkup' => $element_markup,
      '#elementClass' => $element_class,
      '#video_id' => 'data',
      '#attached' => [
        'library' => [
          'site_studio_wistia_video/ss_wistia_video',
        ],
        'drupalSettings' => $settings,
      ],
    ];
  }

   /**
   * Returns player settings from the system wide configuration.
   *
   * @return array
   *   Array containing player settings as a key.
   */
  protected function getGlobalPlayerSettings() {
    $globalConfig = \Drupal::configFactory()->get('cwe_ss_custom_elements.settings');
    return [
      'player_settings' => [
        'video_foam' => 'true',
        'color' => $globalConfig->get('player_color'),
        'display_play_button' => $globalConfig->get('display_play_button') === 1 ? 'true' : 'false',
        'video_width' => $globalConfig->get('video_width'),
        'video_height' => $globalConfig->get('video_height'),
      ],
    ];
  }
}